unit Unit1;

// soutezici c. 24

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Buttons, ExtCtrls, StdCtrls;

type
  TMainForm = class(TForm)
    Rodokmen: TStringGrid;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    OpenBtn: TButton;
    SaveBtn: TButton;
    NewBtn: TButton;
    GroupBox2: TGroupBox;
    NewItemBtn: TButton;
    EditItemBtn: TButton;
    DeleteItemBtn: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    lbJmeno: TLabel;
    lbPohlavi: TLabel;
    lbNarozeni: TLabel;
    lbUmrti: TLabel;
    lbMatka: TLabel;
    lbOtec: TLabel;
    GroupBox4: TGroupBox;
    ComboBox1: TComboBox;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure RodokmenSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure OpenBtnClick(Sender: TObject);
    procedure EditItemBtnClick(Sender: TObject);
    procedure NewItemBtnClick(Sender: TObject);
    procedure DeleteItemBtnClick(Sender: TObject);
    procedure NewBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    procedure ObnovInfo(ARow: Integer);
  public
    function ZjistiSeznamMuzu: TStringList;
    function ZjistiSeznamZen: TStringList;
  end;

var
  MainForm: TMainForm;

implementation

uses Unit2;

{$R *.DFM}

function TMainForm.ZjistiSeznamMuzu: TStringList;
var
  I: Integer;
begin // z rodokmenu vypise do stringlistu seznam vsech muzu
  Result := TStringList.Create;
  for I := 1 to Rodokmen.RowCount - 1 do begin
    if (Rodokmen.Cells[3, I] <> 'Z') and (Rodokmen.Cells[0, I] <> '') then
      with Rodokmen do
        Result.Add(Cells[0, I] + ': ' + Cells[1, I] + ' ' + Cells[2, I]);
  end;
end;

function TMainForm.ZjistiSeznamZen: TStringList;
var
  I: Integer;
begin // z rodokmenu vypise do stringlistu seznam vsech zen
  Result := TStringList.Create;
  for I := 1 to Rodokmen.RowCount - 1 do begin
    if (Rodokmen.Cells[3, I] <> 'M') and (Rodokmen.Cells[0, I] <> '') then
      with Rodokmen do
        Result.Add(Cells[0, I] + ': ' + Cells[1, I] + ' ' + Cells[2, I]);
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  with Rodokmen do begin
    Cells[0, 0] := 'ID';
    Cells[1, 0] := 'Jmno';
    Cells[2, 0] := 'Pjemn';
    Cells[3, 0] := 'Pohlav';
    Cells[4, 0] := 'Narozen';
    Cells[5, 0] := 'mrt';
    Cells[6, 0] := 'Matka';
    Cells[7, 0] := 'Otec';
    ColWidths[1] := 200;
    ColWidths[2] := 100;
  end;
end;

procedure TMainForm.OpenBtnClick(Sender: TObject);
var
  F: TextFile;
  S, Tag: string;
  RadekTabulky: Integer;

function CtiRadek(var F: TextFile): string;
var
  Ch: Char;
begin
  Result := '';
  Read(F, Ch);
  while (Ch <> #10) and (Ch <> #13) and not EOF(F) do begin { nelze cist ReadLn }
    Result := Result + Ch;                                  { radky nekonci CR/LF}
    Read(F, Ch);
  end;
  while (Result <> '') and (Result[1] = ' ') do Delete(Result, 1, 1);
end;

function VytahniText(S, Tag: string): string; // zkopiruje text v definovanem tagu
var
  StartTag, EndTag: string;
begin
  StartTag := '<' + Tag + '>';
  EndTag := '</' + Tag + '>';
  Result := Copy(S, Pos(StartTag, S) + Length(StartTag), Pos(EndTag, S) - Pos(StartTag, S) - Length(StartTag));
end;

begin
  if OpenDialog1.Execute then begin
    RadekTabulky := 1;
    AssignFile(F, OpenDialog1.FileName);
    Reset(F);
    while not EOF(F) do begin
      S := CtiRadek(F);
      Tag := Copy(S, 2, Pos('>', S) - 2);
      if Tag = 'osoba' then begin // nalezen tag osoba
        S := CtiRadek(F); Tag := Copy(S, 2, Pos('>', S) - 2);
        while Tag <> '/osoba' do begin // dokud neni konec tagu osoba
          if Tag = 'id' then Rodokmen.Cells[0, RadekTabulky] := VytahniText(S, 'id')
          else if Tag = 'jmeno' then Rodokmen.Cells[1, RadekTabulky] := VytahniText(S, 'jmeno')
          else if Tag = 'prijmeni' then Rodokmen.Cells[2, RadekTabulky] := VytahniText(S, 'prijmeni')
          else if Tag = 'pohlavi' then Rodokmen.Cells[3, RadekTabulky] := VytahniText(S, 'pohlavi')
          else if Tag = 'narozeni' then Rodokmen.Cells[4, RadekTabulky] := VytahniText(S, 'narozeni')
          else if Tag = 'umrti' then Rodokmen.Cells[5, RadekTabulky] := VytahniText(S, 'umrti')
          else if Tag = 'matka' then Rodokmen.Cells[6, RadekTabulky] := VytahniText(S, 'matka')
          else if Tag = 'otec' then Rodokmen.Cells[7, RadekTabulky] := VytahniText(S, 'otec');
          S := CtiRadek(F); Tag := Copy(S, 2, Pos('>', S) - 2);
        end;
        Inc(RadekTabulky); // zvysit pocet radku
      end;
    end;
    CloseFile(F);
    Rodokmen.RowCount := RadekTabulky;
  end;
end;

procedure TMainForm.ObnovInfo(ARow: Integer);
var             // zobrazuje informace o vybranem zaznamu
  Otec, Matka: string;
  I: Integer;
begin
  ComboBox1.ItemIndex := -1;
  with Rodokmen do begin
    lbJmeno.Caption := Cells[1, ARow] + ' ' + Cells[2, ARow];
    if Cells[3, ARow] = 'M' then lbPohlavi.Caption := 'Mu'
    else if Cells[3, ARow] = 'Z' then lbPohlavi.Caption := 'ena'
    else lbPohlavi.Caption := 'nedefinovno';
    lbNarozeni.Caption := Cells[4, ARow];
    lbUmrti.Caption := Cells[5, ARow];

    Matka := Cells[6, ARow];
    Otec := Cells[7, ARow];
    for I := 1 to RowCount - 1 do begin
      if Cells[0, I] = Matka then Matka := Cells[1, I] + ' ' + Cells[2, I] + ' (' + Cells[0, I] + ')';
      if Cells[0, I] = Otec then Otec := Cells[1, I] + ' ' + Cells[2, I] + ' (' + Cells[0, I] + ')';
    end;
    lbMatka.Caption := Matka;
    lbOtec.Caption := Otec;
  end;

  ComboBox1Change(nil);
end;

procedure TMainForm.RodokmenSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  ObnovInfo(ARow); // pri vyberu obnovit informace
end;

procedure TMainForm.EditItemBtnClick(Sender: TObject);
var
  Jmeno, Prijmeni, Pohlavi, Narozeni, Umrti, Matka, Otec: string;
begin
  with Rodokmen do begin
    if RowCount < 2 then Exit; // nema smysl
    if (RowCount = 2) and (Cells[0, 1] = '') then Exit; // radek je prazdny
    if RowCount < 2 then Exit;
    Jmeno := Cells[1, Row];
    Prijmeni := Cells[2, Row];
    Pohlavi := Cells[3, Row];
    Narozeni := Cells[4, Row];
    Umrti := Cells[5, Row];
    Matka := Cells[6, Row];
    Otec := Cells[7, Row];
    if EditForm.Edituj(Cells[0, Row], Jmeno, Prijmeni, Pohlavi, Narozeni, Umrti, Matka, Otec) then begin
      Cells[1, Row] := Jmeno;
      Cells[2, Row] := Prijmeni;
      Cells[3, Row] := Pohlavi;
      Cells[4, Row] := Narozeni;
      Cells[5, Row] := Umrti;
      Cells[6, Row] := Matka;
      Cells[7, Row] := Otec;
    end;
  end;
end;

procedure TMainForm.NewItemBtnClick(Sender: TObject);
var
  VypocetID: Integer;
  ID, Jmeno, Prijmeni, Pohlavi, Narozeni, Umrti, Matka, Otec: string;
  NewRow: Integer;

function NajdiID(ID: string): Boolean;
var           // vraci True kdyz ID uz existuje
  I: Integer;
begin
  Result := False;
  for I := 1 to Rodokmen.RowCount - 1 do begin
    if Rodokmen.Cells[0, I] = ID then begin
      Result := True;
      Exit;
    end;
  end;
end;

begin
  with Rodokmen do begin
    if Cells[0, 1] = '' then VypocetID := 1
                        else VypocetID := RowCount;
    ID := 'I' + IntToStr(VypocetID);
    while NajdiID(ID) do begin
      Inc(VypocetID);
      ID := 'I' + IntToStr(VypocetID);
    end;
    if EditForm.Edituj(ID, Jmeno, Prijmeni, Pohlavi, Narozeni, Umrti, Matka, Otec) then begin
      if Cells[0, 1] <> '' then begin
        NewRow := RowCount;
        RowCount := RowCount + 1;
      end else begin
        NewRow := 1;
      end;
      Cells[0, NewRow] := ID;
      Cells[1, NewRow] := Jmeno;
      Cells[2, NewRow] := Prijmeni;
      Cells[3, NewRow] := Pohlavi;
      Cells[4, NewRow] := Narozeni;
      Cells[5, NewRow] := Umrti;
      Cells[6, NewRow] := Matka;
      Cells[7, NewRow] := Otec;
    end;
  end;
end;

procedure TMainForm.DeleteItemBtnClick(Sender: TObject);
var
  I: Integer;
begin
  with Rodokmen do begin
    if RowCount < 2 then Exit;
    if RowCount = 2 then begin
      Rows[Row].Clear;
    end else begin
      for I := Row to RowCount - 2 do begin
        Rows[I].Assign(Rows[I + 1]);// precislovani
      end;
      RowCount := RowCount - 1; // a odmazani posledniho zaznamu
    end;
  end;
end;

procedure TMainForm.NewBtnClick(Sender: TObject);
begin
  Rodokmen.RowCount := 2;
  Rodokmen.Rows[1].Clear;
  ObnovInfo(1);
end;

procedure TMainForm.SaveBtnClick(Sender: TObject);
var
  F: TextFile;
  I: Integer;
begin
  if SaveDialog1.Execute then begin
    AssignFile(F, SaveDialog1.FileName);
    ReWrite(F); {prepisuje bez vyzvani, ulozeni je automaticky ulozit jako}
    WriteLn(F, '<rodokmen>');
    with Rodokmen do begin
      for I := 1 to RowCount - 1 do begin
        WriteLn(F, '   <osoba>');
        WriteLn(F, '      <id>' + Cells[0, I] + '</id>');
        WriteLn(F, '      <jmeno>' + Cells[1, I] + '</jmeno>');
        WriteLn(F, '      <prijmeni>' + Cells[2, I] + '</prijmeni>');
        WriteLn(F, '      <pohlavi>' + Cells[3, I] + '</pohlavi>');
        if Cells[4, I] <> '' then WriteLn(F, '      <narozeni>' + Cells[4, I] + '</narozeni>')
                             else WriteLn(F, '      <narozeni/>');
        if Cells[5, I] <> '' then WriteLn(F, '      <umrti>' + Cells[5, I] + '</umrti>')
                             else WriteLn(F, '      <umrti/>');
        if Cells[6, I] <> '' then WriteLn(F, '      <matka>' + Cells[6, I] + '</matka>')
                             else WriteLn(F, '      <matka/>');
        if Cells[7, I] <> '' then WriteLn(F, '      <otec>' + Cells[7, I] + '</otec>')
                             else WriteLn(F, '      <otec/>');
        WriteLn(F, '   </osoba>');
      end;
    end;
    WriteLn(F, '</rodokmen>');
    CloseFile(F);
  end;
end;

procedure TMainForm.ComboBox1Change(Sender: TObject);
var
  Seznam: TStringList;
  I, J: Integer;
  ARow: Integer;
begin
  with Rodokmen do begin
    ARow := Row;
    case ComboBox1.ItemIndex of
      -1: ListBox1.Items.Clear;
      0: begin // manzel/manzelka
           Seznam := TStringList.Create;
           if Cells[3, ARow] = 'M' then begin
             for I := 1 to RowCount - 1 do begin
               if Cells[7, I] = Cells[0, ARow] then Seznam.Add(Cells[6, I]);
             end;
           end else begin {hermafroditi bez pohlavi zarazeny mezi zeny}
             for I := 1 to RowCount - 1 do begin
               if Cells[6, I] = Cells[0, ARow] then Seznam.Add(Cells[7, I]);
             end;
           end;

           Seznam.Sort; // setridit
           I := 0; // zlikvidovat duplikaty
           while I < Seznam.Count - 1 do begin
             if Seznam[I] = Seznam[I + 1] then Seznam.Delete(I + 1)
                                              else I := I + 1;
           end;

           for I := 0 to Seznam.Count - 1 do begin
             for J := 1 to RowCount - 1 do begin
               if Seznam[I] = Cells[0, J] then Seznam[I] := Cells[1, J] + ' ' + Cells[2, J] + ' (' + Cells[0, J] + ')';
             end;
           end;
           ListBox1.Items.Assign(Seznam);

           Seznam.Free;
         end;
      1: begin // deti
           Seznam := TStringList.Create;
           if Cells[3, ARow] = 'M' then begin
             for I := 1 to RowCount - 1 do begin
               if Cells[7, I] = Cells[0, ARow] then Seznam.Add(Cells[1, I] + ' ' + Cells[2, I] + ' (' + Cells[0, I] + ')');
             end;
           end else begin {hermafroditi bez pohlavi zarazeny mezi zeny}
             for I := 1 to RowCount - 1 do begin
               if Cells[6, I] = Cells[0, ARow] then Seznam.Add(Cells[1, I] + ' ' + Cells[2, I] + ' (' + Cells[0, I] + ')');
             end;
           end;

           ListBox1.Items.Assign(Seznam);

           Seznam.Free;
         end;
      2: begin // rodice
           Seznam := TStringList.Create;
           for I := 1 to RowCount - 1 do begin
             if Cells[0, I] = Cells[6, ARow] then Seznam.Add(Cells[1, I] + ' ' + Cells[2, I] + ' (' + Cells[0, I] + ')');
             if Cells[0, I] = Cells[7, ARow] then Seznam.Add(Cells[1, I] + ' ' + Cells[2, I] + ' (' + Cells[0, I] + ')');
           end;

           ListBox1.Items.Assign(Seznam);

           Seznam.Free;
         end;
      3: begin // prarodice
           Seznam := TStringList.Create;
           for I := 1 to RowCount - 1 do begin
             if Cells[0, I] = Cells[6, ARow] then begin
               for J := 1 to RowCount - 1 do begin
                 if Cells[0, J] = Cells[6, I] then Seznam.Add(Cells[1, J] + ' ' + Cells[2, J] + ' (' + Cells[0, J] + ')');
                 if Cells[0, J] = Cells[7, I] then Seznam.Add(Cells[1, J] + ' ' + Cells[2, J] + ' (' + Cells[0, J] + ')');
               end;
             end;
             if Cells[0, I] = Cells[7, ARow] then begin
               for J := 1 to RowCount - 1 do begin
                 if Cells[0, J] = Cells[6, I] then Seznam.Add(Cells[1, J] + ' ' + Cells[2, J] + ' (' + Cells[0, J] + ')');
                 if Cells[0, J] = Cells[7, I] then Seznam.Add(Cells[1, J] + ' ' + Cells[2, J] + ' (' + Cells[0, J] + ')');
               end;
             end;
           end;

           ListBox1.Items.Assign(Seznam);

           Seznam.Free;
         end;
       // ostatni
    end;
  end;
end;

end.
